=== external/CMakeLists.txt ===

add_subdirectory(gtest-1.6.0)
add_subdirectory(libdivsufsort-2.0.1)
