=== external/gtest-1.6.0/include/CMakeLists.txt ===

add_subdirectory(gtest)
