=== debian/changelog ===
libsdsl (2.0.3-4) unstable; urgency=medium

  * debian/clean: Enable building twice in a row
  * cme fix dpkg-control
  * Vcs-fields now pointing to Debian Science repository
  * Add myself to uploaders

 -- Andreas Tille <tille@debian.org>  Tue, 12 Apr 2016 18:26:06 +0200

libsdsl (2.0.3-3) unstable; urgency=medium

  * d/control: add missing architectures (thanks Adam Borowski!)

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 10 Apr 2016 19:38:42 +0200

libsdsl (2.0.3-2) unstable; urgency=medium

  * Upload to unstable
  * d/control: move to Debian Science team
  * d/control: bump Standard Version to 3.9.7 (no changes needed)
  * d/control: restrict to four supported architectures

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 10 Apr 2016 17:25:31 +0200

libsdsl (2.0.3-1) experimental; urgency=low

  * Initial release (Closes: #796962)

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 04 Aug 2015 20:28:45 +0200
